-- --------------------------------------------------------- --
--	PWM test bench											 --
-- ========================================================= --
--	Copyright (c)2007 t.hara								 --
-- --------------------------------------------------------- --

library	ieee;
use		ieee.std_logic_1164.all;
use		ieee.std_logic_unsigned.all;
use		ieee.std_logic_arith.all;

entity tb is
end tb;

architecture behavior of tb is

	-- test target
	component esepwm
		generic (
			MSBI : integer
		);
		port (
			clk     : in std_logic;
			reset   : in std_logic;
			DACin   : in std_logic_vector(MSBI downto 0);
			DACout  : out std_logic
		);
	end component;

	constant CYCLE : time := 10 ns;

	signal clk    : std_logic;
	signal reset  : std_logic;
	signal DACin  : std_logic_vector ( 11 downto 0 );
	signal DACout : std_logic;

	signal	tb_end	: std_logic := '0';
begin

	--	instance
	u_target: esepwm
	generic map (
		MSBI	=> 11
	)
	port map (
		clk		=> clk,
		reset	=> reset,
		DACin	=> DACin,
		DACout	=> DACout
	);

	-- ----------------------------------------------------- --
	--	clock generator										 --
	-- ----------------------------------------------------- --
	process
	begin
		if( tb_end = '1' )then
			wait;
		end if;
		clk <= '0';
		wait for 5 ns;
		clk <= '1';
		wait for 5 ns;
	end process;

	-- ----------------------------------------------------- --
	--	test bench											 --
	-- ----------------------------------------------------- --
	process
	begin
		-- init
	    DACin  <=  conv_std_logic_vector( 4095, 12 );

		-- reset
		reset <= '1';
		for I in 0 to 4 loop
			wait until( clk'event and clk = '1');
		end loop;
		reset <= '0';
		wait until( clk'event and clk = '1');

		-- 肷܂ 32768 l 
		for J in 0 to 12 loop
			DACin <= conv_std_logic_vector( 4095, 12 );
			for I in 0 to 5 loop
				wait until( clk'event and clk = '1');
			end loop;
		end loop;

		-- reset
		-- FIRRAMs肪oĂ̂ŁA̕sŋ PWM 񃊃Zbg
		reset <= '1';
		for I in 0 to 4 loop
			wait until( clk'event and clk = '1');
		end loop;
		reset <= '0';
		wait until( clk'event and clk = '1');

		-- 肷܂ 0 l 
		for J in 0 to 12 loop
			DACin <= conv_std_logic_vector( 4095, 12 );
			for I in 0 to 5 loop
				wait until( clk'event and clk = '1');
			end loop;
		end loop;

		-- `Ă݂ 
		DACin <=  conv_std_logic_vector( 4095 + 100, 12 );
		for J in 0 to 6 loop
			for I in 0 to 5 loop
				wait until( clk'event and clk = '1');
			end loop;
		end loop;

		DACin <=  conv_std_logic_vector( 4095, 12 );
		for J in 0 to 10 loop
			for I in 0 to 5 loop
				wait until( clk'event and clk = '1');
			end loop;
		end loop;

		tb_end <= '1';
		wait;
	end process;

end behavior;
